/*
 * @license
 * chartjs-plugin-style
 * https://github.com/nagix/chartjs-plugin-style/
 * Version: 0.4.0
 *
 * Copyright 2019 Akihiko Kusanagi
 * Released under the MIT license
 * https://github.com/nagix/chartjs-plugin-style/blob/master/LICENSE.md
 */
!function(e,o){"object"==typeof exports&&"undefined"!=typeof module?o(require("chart.js")):"function"==typeof define&&define.amd?define(["chart.js"],o):o(e.Chart)}(this,function(o){"use strict";var r=(o=o&&o.hasOwnProperty("default")?o.default:o).helpers,f=r.options.resolve,s=1e6;function w(e){return-1!==e.indexOf("Color")}var x={styleKeys:["shadowOffsetX","shadowOffsetY","shadowBlur","shadowColor","bevelWidth","bevelHighlightColor","bevelShadowColor","innerGlowWidth","innerGlowColor","outerGlowWidth","outerGlowColor","backgroundOverlayColor","backgroundOverlayMode"],lineStyleKeys:["shadowOffsetX","shadowOffsetY","shadowBlur","shadowColor","outerGlowWidth","outerGlowColor"],pointStyleKeys:["pointShadowOffsetX","pointShadowOffsetY","pointShadowBlur","pointShadowColor","pointBevelWidth","pointBevelHighlightColor","pointBevelShadowColor","pointInnerGlowWidth","pointInnerGlowColor","pointOuterGlowWidth","pointOuterGlowColor","pointBackgroundOverlayColor","pointBackgroundOverlayMode"],hoverStyleKeys:["hoverShadowOffsetX","hoverShadowOffsetY","hoverShadowBlur","hoverShadowColor","hoverBevelWidth","hoverBevelHighlightColor","hoverBevelShadowColor","hoverInnerGlowWidth","hoverInnerGlowColor","hoverOuterGlowWidth","hoverOuterGlowColor","hoverBackgroundOverlayColor","hoverBackgroundOverlayMode"],pointHoverStyleKeys:["pointHoverShadowOffsetX","pointHoverShadowOffsetY","pointHoverShadowBlur","pointHoverShadowColor","pointHoverBevelWidth","pointHoverBevelHighlightColor","pointHoverBevelShadowColor","pointHoverInnerGlowWidth","pointHoverInnerGlowColor","pointHoverOuterGlowWidth","pointHoverOuterGlowColor","pointHoverBackgroundOverlayColor","pointHoverBackgroundOverlayMode"],drawBackground:function(e,o){var r=e.borderWidth;e.borderWidth=0,o(),e.borderWidth=r},drawBorder:function(e,o){var r=e.backgroundColor;e.borderWidth&&(e.backgroundColor="rgba(0, 0, 0, 0)",o(),e.backgroundColor=r)},drawShadow:function(e,o,r,t,l,a,d){var n=e.ctx,i=e.currentDevicePixelRatio;n.save(),n.shadowOffsetX=(o+s)*i,n.shadowOffsetY=r*i,n.shadowBlur=t*i,n.shadowColor=l,d&&(n.globalCompositeOperation="destination-over"),n.translate(-s,0),a(),n.restore()},setPath:function(e,o){e.save(),e.beginPath(),e.clip(),o(),e.restore()},drawBevel:function(e,o,r,t,l){var a=e.ctx,d=e.currentDevicePixelRatio,n=o*d*5/6;o&&(a.save(),a.clip(),a.translate(-s,0),this.setPath(a,l),a.rect(0,0,e.width,e.height),a.fillStyle="black",a.shadowOffsetX=s*d-n,a.shadowOffsetY=-n,a.shadowBlur=n,a.shadowColor=t,navigator&&navigator.userAgent.match("Windows.+Firefox")||(a.globalCompositeOperation="source-atop"),a.fill("evenodd"),a.shadowOffsetX=s*d+n,a.shadowOffsetY=n,a.shadowColor=r,a.fill("evenodd"),a.restore())},drawGlow:function(e,o,r,t,l,a){var d=e.ctx,n=e.currentDevicePixelRatio;o&&(d.save(),this.setPath(d,l),a&&d.rect(0,0,e.width,e.height),d.clip("evenodd"),d.translate(-s,0),this.setPath(d,l),a||d.rect(0,0,e.width,e.height),d.lineWidth=t,d.strokeStyle="black",d.fillStyle="black",d.shadowOffsetX=s*n,d.shadowBlur=o*n,d.shadowColor=r,d.fill("evenodd"),t&&d.stroke(),d.restore())},drawInnerGlow:function(e,o,r,t,l){this.drawGlow(e,o,r,t,l)},drawOuterGlow:function(e,o,r,t,l){this.drawGlow(e,o,r,t,l,!0)},drawBackgroundOverlay:function(e,o,r,t){var l=e.ctx;o&&(l.save(),this.setPath(l,t),l.fillStyle=o,l.globalCompositeOperation=r,l.fill(),l.restore())},opaque:function(e){return 0<r.color(e).alpha()},getHoverColor:function(e){return void 0!==e?r.getHoverColor(e):e},mergeStyle:function(o,r){return this.styleKeys.forEach(function(e){o[e]=r[e]}),o},saveStyle:function(e){var o=e._model,r=e.$previousStyle;r&&this.mergeStyle(r,o)},resolveStyle:function(e,o,r,t,l){var a,d,n,i,s,h=e.data.datasets[o._datasetIndex],u=o.custom||{},v=this.styleKeys,c=l?this.hoverStyleKeys:v,p={};for(a=0,d=v.length;a<d;++a)n=v[a],i=c[a],s=t[n],p[n]=f([u[i],h[i],l&&w(n)?this.getHoverColor(s):s],void 0,r);return p},resolveLineStyle:function(e,o,r){var t,l,a,d=this.lineStyleKeys,n={};for(t=0,l=d.length;t<l;++t)n[a=d[t]]=f([e[a],o[a],r[a]]);return n},resolvePointStyle:function(e,o,r,t,l){var a,d,n,i,s=e.data.datasets[o._datasetIndex],h=o.custom||{},u=this.styleKeys,v=l?this.hoverStyleKeys:u,c=l?this.pointHoverStyleKeys:this.pointStyleKeys,p={};for(a=0,d=u.length;a<d;++a)i=t[n=u[a]],p[n]=f([h[v[a]],s[c[a]],l?w(n)?this.getHoverColor(i):i:s[n],i],void 0,r);return p}},t=o.helpers;function h(e,o){if(void 0===o)return e;var r=t.color(e);return r.alpha(o*r.alpha()).rgbaString()}var u=o.Tooltip,l=u.extend({initialize:function(){u.prototype.initialize.apply(this,arguments);var e=this._model,o=this._options;e.shadowOffsetX=o.shadowOffsetX,e.shadowOffsetY=o.shadowOffsetY,e.shadowBlur=o.shadowBlur,e.shadowColor=o.shadowColor,e.bevelWidth=o.bevelWidth,e.bevelHighlightColor=o.bevelHighlightColor,e.bevelShadowColor=o.bevelShadowColor,e.innerGlowWidth=o.innerGlowWidth,e.innerGlowColor=o.innerGlowColor,e.outerGlowWidth=o.outerGlowWidth,e.outerGlowColor=o.outerGlowColor},update:function(){u.prototype.update.apply(this,arguments);var e=this._model,o=this._options;return e.shadowOffsetX=o.shadowOffsetX,e.shadowOffsetY=o.shadowOffsetY,e.shadowBlur=o.shadowBlur,e.shadowColor=o.shadowColor,e.bevelWidth=o.bevelWidth,e.bevelHighlightColor=o.bevelHighlightColor,e.bevelShadowColor=o.bevelShadowColor,e.innerGlowWidth=o.innerGlowWidth,e.innerGlowColor=o.innerGlowColor,e.outerGlowWidth=o.outerGlowWidth,e.outerGlowColor=o.outerGlowColor,this},drawBackground:function(e,o,r,t,l){var a=this,d=arguments,n=a._chart,i=x.opaque(o.borderColor)&&0<o.borderWidth?o.borderWidth/2:0,s=function(){u.prototype.drawBackground.apply(a,d)};x.drawShadow(n,o.shadowOffsetX,o.shadowOffsetY,o.shadowBlur,o.shadowColor,s),x.opaque(o.backgroundColor)&&(x.drawBackground(o,s),x.drawBevel(n,o.bevelWidth+i,h(o.bevelHighlightColor,l),h(o.bevelShadowColor,l),s)),x.drawInnerGlow(n,o.innerGlowWidth,h(o.innerGlowColor,l),o.borderWidth,s),x.drawOuterGlow(n,o.outerGlowWidth,h(o.outerGlowColor,l),o.borderWidth,s),x.drawBorder(o,s)}}),d=o.helpers;d.extend(o.prototype,{initToolTip:function(){var e=this;e.tooltip=new l({_chart:e,_chartInstance:e,_data:e.data,_options:e.options.tooltips},e)}}),d.valueOrDefault=d.valueOrDefault||d.getValueOrDefault,d.valueAtIndexOrDefault=d.valueAtIndexOrDefault||d.getValueAtIndexOrDefault,d.mergeIf=d.mergeIf||function(e,o){return d.configMerge.call(this,o,e)},d.options=d.options||{},d.options.resolve=d.options.resolve||function(e,o,r){var t,l,a;for(t=0,l=e.length;t<l;++t)if(void 0!==(a=e[t])&&(void 0!==o&&"function"==typeof a&&(a=a(o)),void 0!==r&&d.isArray(a)&&(a=a[r]),void 0!==a))return a},o.layouts=o.layouts||o.layoutService;var n=o.elements.Arc,e=n.extend({draw:function(){var e=this,o=arguments,r=e._chart,t=e._view,l=x.opaque(t.borderColor)&&0<t.borderWidth?t.borderWidth/2:0,a=function(){n.prototype.draw.apply(e,o)};x.drawShadow(r,t.shadowOffsetX,t.shadowOffsetY,t.shadowBlur,t.shadowColor,a,!0),x.opaque(t.backgroundColor)&&(x.drawBackground(t,a),x.drawBackgroundOverlay(r,t.backgroundOverlayColor,t.backgroundOverlayMode,a),x.drawBevel(r,t.bevelWidth+l,t.bevelHighlightColor,t.bevelShadowColor,a)),x.drawInnerGlow(r,t.innerGlowWidth,t.innerGlowColor,t.borderWidth,a),x.drawOuterGlow(r,t.outerGlowWidth,t.outerGlowColor,t.borderWidth,a),x.drawBorder(t,a)}}),a=o.elements.Line,i=a.extend({draw:function(){var e=this,o=arguments,r=e._chart,t=e._view,l=function(){a.prototype.draw.apply(e,o)};x.drawShadow(r,t.shadowOffsetX,t.shadowOffsetY,t.shadowBlur,t.shadowColor,l),x.drawShadow(r,0,0,t.outerGlowWidth,t.outerGlowColor,l),x.drawBorder(t,l)}}),v=o.elements.Point,c=v.extend({draw:function(){var e=this,o=arguments,r=e._chart,t=e._view,l=x.opaque(t.borderColor)&&0<t.borderWidth?t.borderWidth/2:0,a=function(){v.prototype.draw.apply(e,o)};x.drawShadow(r,t.shadowOffsetX,t.shadowOffsetY,t.shadowBlur,t.shadowColor,a,!0),x.opaque(t.backgroundColor)&&(x.drawBackground(t,a),x.drawBackgroundOverlay(r,t.backgroundOverlayColor,t.backgroundOverlayMode,a),x.drawBevel(r,t.bevelWidth+l,t.bevelHighlightColor,t.bevelShadowColor,a)),x.drawInnerGlow(r,t.innerGlowWidth,t.innerGlowColor,t.borderWidth,a),x.drawOuterGlow(r,t.outerGlowWidth,t.outerGlowColor,t.borderWidth,a),x.drawBorder(t,a)}}),p=o.elements.Rectangle,b=p.extend({draw:function(){var e=this,o=arguments,r=e._chart,t=e._view,l=x.opaque(t.borderColor)&&0<t.borderWidth?t.borderWidth/2:0,a=function(){p.prototype.draw.apply(e,o)};x.drawShadow(r,t.shadowOffsetX,t.shadowOffsetY,t.shadowBlur,t.shadowColor,a,!0),x.opaque(t.backgroundColor)&&(x.drawBackground(t,a),x.drawBackgroundOverlay(r,t.backgroundOverlayColor,t.backgroundOverlayMode,a),x.drawBevel(r,t.bevelWidth+l,t.bevelHighlightColor,t.bevelShadowColor,a)),x.drawInnerGlow(r,t.innerGlowWidth,t.innerGlowColor,t.borderWidth,a),x.drawOuterGlow(r,t.outerGlowWidth,t.outerGlowColor,t.borderWidth,a),x.drawBorder(t,a)}}),g=o.helpers,y=g.options.resolve,C=o.controllers.bar,S=C.extend({dataElementType:b,updateElement:function(e,o,r){var t=this,l=t.chart,a=t.getMeta(),d=t.getDataset(),n=e.custom||{},i=l.options.elements.rectangle;e._xScale=t.getScaleForId(a.xAxisID),e._yScale=t.getScaleForId(a.yAxisID),e._datasetIndex=t.index,e._index=o,e._model={datasetLabel:d.label,label:l.data.labels[o],borderSkipped:g.valueOrDefault(n.borderSkipped,i.borderSkipped),backgroundColor:y([n.backgroundColor,d.backgroundColor,i.backgroundColor],void 0,o),borderColor:y([n.borderColor,d.borderColor,i.borderColor],void 0,o),borderWidth:y([n.borderWidth,d.borderWidth,i.borderWidth],void 0,o)},g.merge(e._model,x.resolveStyle(l,e,o,i)),t.updateElementGeometry(e,o,r),e.pivot()},setHoverStyle:function(e){var o=e._model;C.prototype.setHoverStyle.apply(this,arguments),x.saveStyle(e),g.merge(o,x.resolveStyle(this.chart,e,e._index,o,!0))},removeHoverStyle:function(e){e.$previousStyle||g.merge(e._model,x.resolveStyle(this.chart,e,e._index,this.chart.options.elements.rectangle)),C.prototype.removeHoverStyle.apply(this,arguments)}}),m=o.helpers,O=m.valueOrDefault,W=x.getHoverColor,G=o.controllers.bubble,k=G.extend({dataElementType:c,updateElement:function(e,o,r){var t=this,l=t.getMeta(),a=e.custom||{},d=t.getScaleForId(l.xAxisID),n=t.getScaleForId(l.yAxisID),i=t._resolveElementOptions(e,o),s=t.getDataset().data[o],h=t.index,u=r?d.getPixelForDecimal(.5):d.getPixelForValue("object"==typeof s?s:NaN,o,h),v=r?n.getBasePixel():n.getPixelForValue(s,o,h);e._xScale=d,e._yScale=n,e._options=i,e._datasetIndex=h,e._index=o,e._model={backgroundColor:i.backgroundColor,borderColor:i.borderColor,borderWidth:i.borderWidth,hitRadius:i.hitRadius,pointStyle:i.pointStyle,rotation:i.rotation,radius:r?0:i.radius,skip:a.skip||isNaN(u)||isNaN(v),x:u,y:v},x.mergeStyle(e._model,i),e.pivot()},setHoverStyle:function(e){G.prototype.setHoverStyle.apply(this,arguments);var o=e._model,r=e._options;x.saveStyle(e),o.shadowOffsetX=O(r.hoverShadowOffsetX,r.shadowOffsetX),o.shadowOffsetY=O(r.hoverShadowOffsetY,r.shadowOffsetY),o.shadowBlur=O(r.hoverShadowBlur,r.shadowBlur),o.shadowColor=O(r.hoverShadowColor,W(r.shadowColor)),o.bevelWidth=O(r.hoverBevelWidth,r.bevelWidth),o.bevelHighlightColor=O(r.hoverBevelHighlightColor,W(r.bevelHighlightColor)),o.bevelShadowColor=O(r.hoverBevelShadowColor,W(r.bevelShadowColor)),o.innerGlowWidth=O(r.hoverInnerGlowWidth,r.innerGlowWidth),o.innerGlowColor=O(r.hoverInnerGlowColor,W(r.innerGlowColor)),o.outerGlowWidth=O(r.hoverOuterGlowWidth,r.outerGlowWidth),o.outerGlowColor=O(r.hoverOuterGlowColor,W(r.outerGlowColor)),o.backgroundOverlayColor=O(r.hoverBackgroundOverlayColor,W(r.backgroundOverlayColor)),o.backgroundOverlayMode=O(r.hoverBackgroundOverlayMode,r.backgroundOverlayMode)},removeHoverStyle:function(e){e.$previousStyle||x.mergeStyle(e._model,e._options),G.prototype.removeHoverStyle.apply(this,arguments)},_resolveElementOptions:function(e,o){var r,t,l,a=this.chart,d=a.data.datasets[this.index],n=e.custom||{},i=a.options.elements.point,s=m.options.resolve,h=d.data[o],u={},v={chart:a,dataIndex:o,dataset:d,datasetIndex:this.index},c=["backgroundColor","borderColor","borderWidth","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth","hoverRadius","hitRadius","pointStyle","rotation","shadowOffsetX","shadowOffsetY","shadowBlur","shadowColor","hoverShadowOffsetX","hoverShadowOffsetY","hoverShadowBlur","hoverShadowColor","bevelWidth","bevelHighlightColor","bevelShadowColor","hoverBevelWidth","hoverBevelHighlightColor","hoverBevelShadowColor","innerGlowWidth","innerGlowColor","outerGlowWidth","outerGlowColor","hoverInnerGlowWidth","hoverInnerGlowColor","hoverOuterGlowWidth","hoverOuterGlowColor","backgroundOverlayColor","backgroundOverlayMode","hoverBackgroundOverlayColor","hoverBackgroundOverlayMode"];for(r=0,t=c.length;r<t;++r)u[l=c[r]]=s([n[l],d[l],i[l]],v,o);return u.radius=s([n.radius,h?h.r:void 0,d.radius,i.radius],v,o),u}}),B=o.defaults,_=o.helpers,H=_.options.resolve;B.doughnut.legend.labels.generateLabels=B.pie.legend.labels.generateLabels=function(h){var u=h.data;return u.labels.length&&u.datasets.length?u.labels.map(function(e,o){var r=h.getDatasetMeta(0),t=u.datasets[0],l=r.data[o],a=l&&l.custom||{},d=h.options.elements.arc,n=H([a.backgroundColor,t.backgroundColor,d.backgroundColor],void 0,o),i=H([a.borderColor,t.borderColor,d.borderColor],void 0,o),s=H([a.borderWidth,t.borderWidth,d.borderWidth],void 0,o);return _.merge({text:e,fillStyle:n,strokeStyle:i,lineWidth:s,hidden:isNaN(t.data[o])||r.data[o].hidden,index:o},x.resolveStyle(h,l,o,d))}):[]};var D=o.controllers.doughnut,I=D.extend({dataElementType:e,updateElement:function(e,o,r){var t=this,l=t.chart,a=l.chartArea,d=l.options,n=d.animation,i=(a.left+a.right)/2,s=(a.top+a.bottom)/2,h=d.rotation,u=d.rotation,v=t.getDataset(),c=r&&n.animateRotate?0:e.hidden?0:t.calculateCircumference(v.data[o])*(d.circumference/(2*Math.PI)),p=r&&n.animateScale?0:t.innerRadius,f=r&&n.animateScale?0:t.outerRadius;_.extend(e,{_datasetIndex:t.index,_index:o,_model:{x:i+l.offsetX,y:s+l.offsetY,startAngle:h,endAngle:u,circumference:c,outerRadius:f,innerRadius:p,label:_.valueAtIndexOrDefault(v.label,o,l.data.labels[o])}});var w=e._model,b=e.custom||{},g=d.elements.arc;w.backgroundColor=H([b.backgroundColor,v.backgroundColor,g.backgroundColor],void 0,o),w.borderColor=H([b.borderColor,v.borderColor,g.borderColor],void 0,o),w.borderWidth=H([b.borderWidth,v.borderWidth,g.borderWidth],void 0,o),_.merge(w,x.resolveStyle(l,e,o,g)),r&&n.animateRotate||(w.startAngle=0===o?d.rotation:t.getMeta().data[o-1]._model.endAngle,w.endAngle=w.startAngle+w.circumference),e.pivot()},setHoverStyle:function(e){var o=e._model;D.prototype.setHoverStyle.apply(this,arguments),x.saveStyle(e),_.merge(o,x.resolveStyle(this.chart,e,e._index,o,!0))},removeHoverStyle:function(e){e.$previousStyle||_.merge(e._model,x.resolveStyle(this.chart,e,e._index,this.chart.options.elements.arc)),D.prototype.removeHoverStyle.apply(this,arguments)}}),M=S.extend({getValueScaleId:function(){return this.getMeta().xAxisID},getIndexScaleId:function(){return this.getMeta().yAxisID}}),A=o.helpers,P=A.valueOrDefault,X=A.options.resolve,Y=o.controllers.line;var E=Y.extend({datasetElementType:i,dataElementType:c,update:function(e){var o,r,t,l,a=this,d=a.getMeta(),n=d.dataset,i=d.data||[],s=a.chart.options,h=s.elements.line,u=a.getScaleForId(d.yAxisID),v=a.getDataset(),c=(l=s,P(v.showLine,l.showLines));for(c&&(t=n.custom||{},void 0!==v.tension&&void 0===v.lineTension&&(v.lineTension=v.tension),n._scale=u,n._datasetIndex=a.index,n._children=i,n._model={spanGaps:P(v.spanGaps,s.spanGaps),tension:X([t.tension,v.lineTension,h.tension]),backgroundColor:X([t.backgroundColor,v.backgroundColor,h.backgroundColor]),borderWidth:X([t.borderWidth,v.borderWidth,h.borderWidth]),borderColor:X([t.borderColor,v.borderColor,h.borderColor]),borderCapStyle:X([t.borderCapStyle,v.borderCapStyle,h.borderCapStyle]),borderDash:X([t.borderDash,v.borderDash,h.borderDash]),borderDashOffset:X([t.borderDashOffset,v.borderDashOffset,h.borderDashOffset]),borderJoinStyle:X([t.borderJoinStyle,v.borderJoinStyle,h.borderJoinStyle]),fill:X([t.fill,v.fill,h.fill]),steppedLine:X([t.steppedLine,v.steppedLine,h.stepped]),cubicInterpolationMode:X([t.cubicInterpolationMode,v.cubicInterpolationMode,h.cubicInterpolationMode])},A.merge(n._model,x.resolveLineStyle(t,v,h)),n.pivot()),o=0,r=i.length;o<r;++o)a.updateElement(i[o],o,e);for(c&&0!==n._model.tension&&a.updateBezierControlPoints(),o=0,r=i.length;o<r;++o)i[o].pivot()},updateElement:function(e,o){Y.prototype.updateElement.apply(this,arguments),A.merge(e._model,x.resolvePointStyle(this.chart,e,o,this.chart.options.elements.point))},setHoverStyle:function(e){var o=e._model;Y.prototype.setHoverStyle.apply(this,arguments),x.saveStyle(e),A.merge(o,x.resolvePointStyle(this.chart,e,e._index,o,!0))},removeHoverStyle:function(e){e.$previousStyle||A.merge(e._model,x.resolvePointStyle(this.chart,e,e._index,this.chart.options.elements.point)),Y.prototype.removeHoverStyle.apply(this,arguments)}}),T=o.helpers,R=T.options.resolve;o.defaults.polarArea.legend.labels.generateLabels=function(h){var u=h.data;return u.labels.length&&u.datasets.length?u.labels.map(function(e,o){var r=h.getDatasetMeta(0),t=u.datasets[0],l=r.data[o],a=l.custom||{},d=h.options.elements.arc,n=R([a.backgroundColor,t.backgroundColor,d.backgroundColor],void 0,o),i=R([a.borderColor,t.borderColor,d.borderColor],void 0,o),s=R([a.borderWidth,t.borderWidth,d.borderWidth],void 0,o);return T.merge({text:e,fillStyle:n,strokeStyle:i,lineWidth:s,hidden:isNaN(t.data[o])||r.data[o].hidden,index:o},x.resolveStyle(h,l,o,d))}):[]};var F=o.controllers.polarArea,L=F.extend({dataElementType:e,updateElement:function(e,o,r){var t,l,a=this,d=a.chart,n=a.getDataset(),i=d.options,s=i.animation,h=d.scale,u=d.data.labels,v=h.xCenter,c=h.yCenter,p=i.startAngle,f=e.hidden?0:h.getDistanceFromCenterForValue(n.data[o]);if(a.calculateCircumference){for(var w=a.calculateCircumference(n.data[o]),b=0,g=a.getMeta(),y=0;y<o;++y)isNaN(n.data[y])||g.data[y].hidden||++b;l=(t=p+w*b)+(e.hidden?0:w)}else l=(t=a._starts[o])+(e.hidden?0:a._angles[o]);var C=s.animateScale?0:h.getDistanceFromCenterForValue(n.data[o]);T.extend(e,{_datasetIndex:a.index,_index:o,_scale:h,_model:{x:v,y:c,innerRadius:0,outerRadius:r?C:f,startAngle:r&&s.animateRotate?p:t,endAngle:r&&s.animateRotate?p:l,label:T.valueAtIndexOrDefault(u,o,u[o])}});var S=i.elements.arc,m=e.custom||{},O=e._model;O.backgroundColor=R([m.backgroundColor,n.backgroundColor,S.backgroundColor],void 0,o),O.borderColor=R([m.borderColor,n.borderColor,S.borderColor],void 0,o),O.borderWidth=R([m.borderWidth,n.borderWidth,S.borderWidth],void 0,o),T.merge(O,x.resolveStyle(d,e,o,S)),e.pivot()},setHoverStyle:function(e){var o=e._model;F.prototype.setHoverStyle.apply(this,arguments),x.saveStyle(e),T.merge(o,x.resolveStyle(this.chart,e,e._index,o,!0))},removeHoverStyle:function(e){e.$previousStyle||T.merge(e._model,x.resolveStyle(this.chart,e,e._index,this.chart.options.elements.arc)),F.prototype.removeHoverStyle.apply(this,arguments)}}),N=o.helpers,J=N.options.resolve,K=o.controllers.radar,q=K.extend({datasetElementType:i,dataElementType:c,update:function(r){var t=this,e=t.getMeta(),o=e.dataset,l=e.data,a=o.custom||{},d=t.getDataset(),n=t.chart.options.elements.line,i=t.chart.scale;void 0!==d.tension&&void 0===d.lineTension&&(d.lineTension=d.tension),N.extend(e.dataset,{_datasetIndex:t.index,_scale:i,_children:l,_loop:!0,_model:{tension:J([a.tension,d.lineTension,n.tension]),backgroundColor:J([a.backgroundColor,d.backgroundColor,n.backgroundColor]),borderWidth:J([a.borderWidth,d.borderWidth,n.borderWidth]),borderColor:J([a.borderColor,d.borderColor,n.borderColor]),fill:J([a.fill,d.fill,n.fill]),borderCapStyle:J([a.borderCapStyle,d.borderCapStyle,n.borderCapStyle]),borderDash:J([a.borderDash,d.borderDash,n.borderDash]),borderDashOffset:J([a.borderDashOffset,d.borderDashOffset,n.borderDashOffset]),borderJoinStyle:J([a.borderJoinStyle,d.borderJoinStyle,n.borderJoinStyle])}}),N.merge(e.dataset._model,x.resolveLineStyle(a,d,n)),e.dataset.pivot(),N.each(l,function(e,o){t.updateElement(e,o,r)},t),t.updateBezierControlPoints()},updateElement:function(e,o){K.prototype.updateElement.apply(this,arguments),N.merge(e._model,x.resolvePointStyle(this.chart,e,o,this.chart.options.elements.point))},setHoverStyle:function(e){var o=e._model;K.prototype.setHoverStyle.apply(this,arguments),x.saveStyle(e),N.merge(o,x.resolvePointStyle(this.chart,e,e._index,o,!0))},removeHoverStyle:function(e){e.$previousStyle||N.merge(e._model,x.resolvePointStyle(this.chart,e,e._index,this.chart.options.elements.point)),K.prototype.removeHoverStyle.apply(this,arguments)}}),z=o.defaults,V=o.helpers,$=o.layouts,j=V.isArray,Q=V.valueOrDefault,U=V.options.resolve;z.global.legend.labels.generateLabels=function(r){var e=r.data;return j(e.datasets)?e.datasets.map(function(e,o){return{text:e.label,fillStyle:V.valueAtIndexOrDefault(e.backgroundColor,0),hidden:!r.isDatasetVisible(o),lineCap:e.borderCapStyle,lineDash:e.borderDash,lineDashOffset:e.borderDashOffset,lineJoin:e.borderJoinStyle,lineWidth:e.borderWidth,strokeStyle:e.borderColor,pointStyle:e.pointStyle,shadowOffsetX:U([e.pointShadowOffsetX,e.shadowOffsetX],void 0,0),shadowOffsetY:U([e.pointShadowOffsetY,e.shadowOffsetY],void 0,0),shadowBlur:U([e.pointShadowBlur,e.shadowBlur],void 0,0),shadowColor:U([e.pointShadowColor,e.shadowColor],void 0,0),bevelWidth:U([e.pointBevelWidth,e.bevelWidth],void 0,0),bevelHighlightColor:U([e.pointBevelHighlightColor,e.bevelHighlightColor],void 0,0),bevelShadowColor:U([e.pointBevelShadowColor,e.bevelShadowColor],void 0,0),innerGlowWidth:U([e.pointInnerGlowWidth,e.innerGlowWidth],void 0,0),innerGlowColor:U([e.pointInnerGlowColor,e.innerGlowColor],void 0,0),outerGlowWidth:U([e.pointOuterGlowWidth,e.outerGlowWidth],void 0,0),outerGlowColor:U([e.pointOuterGlowColor,e.outerGlowColor],void 0,0),backgroundOverlayColor:U([e.pointBackgroundOverlayColor,e.backgroundOverlayColor],void 0,0),backgroundOverlayMode:U([e.pointBackgroundOverlayMode,e.backgroundOverlayMode],void 0,0),datasetIndex:o}},this):[]};var Z=o.Legend.extend({draw:function(){var e,o,u=this,v=u.options,c=v.labels,p=z.global,f=p.elements.line,w=u.width,b=u.lineWidths;if(v.display){var g,y=u.ctx,r=Q(c.fontColor,p.defaultFontColor),C=Q(c.fontSize,p.defaultFontSize),t=Q(c.fontStyle,p.defaultFontStyle),l=Q(c.fontFamily,p.defaultFontFamily),a=V.fontString(C,t,l);y.textAlign="left",y.textBaseline="middle",y.lineWidth=.5,y.strokeStyle=r,y.fillStyle=r,y.font=a;var S=(o=C,(e=c).usePointStyle?o*Math.SQRT2:e.boxWidth),m=u.legendHitBoxes,O=u.isHorizontal();g=O?{x:u.left+(w-b[0])/2,y:u.top+c.padding,line:0}:{x:u.left+c.padding,y:u.top+c.padding,line:0};var W=C+c.padding;V.each(u.legendItems,function(e,o){var r,t,l,a,d,n=y.measureText(e.text).width,i=S+C/2+n,s=g.x,h=g.y;O?w<=s+i&&(h=g.y+=W,g.line++,s=g.x=u.left+(w-b[g.line])/2):h+W>u.bottom&&(s=g.x=s+u.columnWidths[g.line]+c.padding,h=g.y=u.top+c.padding,g.line++),function(e,o,r){var t;if(!(isNaN(S)||S<=0)){y.save(),y.fillStyle=Q(r.fillStyle,p.defaultColor),y.lineCap=Q(r.lineCap,f.borderCapStyle),y.lineDashOffset=Q(r.lineDashOffset,f.borderDashOffset),y.lineJoin=Q(r.lineJoin,f.borderJoinStyle),y.lineWidth=Q(r.lineWidth,f.borderWidth),y.strokeStyle=Q(r.strokeStyle,p.defaultColor);var l=0===Q(r.lineWidth,f.borderWidth);if(y.setLineDash&&y.setLineDash(Q(r.lineDash,f.borderDash)),v.labels&&v.labels.usePointStyle){var a=C*Math.SQRT2/2,d=a/Math.SQRT2,n=e+d,i=o+d;t=function(){V.canvas.drawPoint(y,r.pointStyle,a,n,i)}}else t=function(){y.beginPath(),y.rect(e,o,S,C),y.fill(),l||y.stroke()};if(x.drawShadow(u.chart,r.shadowOffsetX,r.shadowOffsetY,r.shadowBlur,r.shadowColor,t,!0),x.opaque(y.fillStyle)){var s=x.opaque(y.strokeStyle)&&0<y.lineWidth?y.lineWidth/2:0;y.save(),y.strokeStyle="rgba(0, 0, 0, 0)",t(),x.drawBackgroundOverlay(u.chart,r.backgroundOverlayColor,r.backgroundOverlayMode,t),x.drawBevel(u.chart,r.bevelWidth+s,r.bevelHighlightColor,r.bevelShadowColor,t),y.restore()}x.drawInnerGlow(u.chart,r.innerGlowWidth,r.innerGlowColor,y.lineWidth,t),x.drawOuterGlow(u.chart,r.outerGlowWidth,r.outerGlowColor,y.lineWidth,t),l||(y.fillStyle="rgba(0, 0, 0, 0)",t()),y.restore()}}(s,h,e),m[o].left=s,m[o].top=h,r=e,t=n,a=S+(l=C/2)+s,d=h+l,y.fillText(r.text,a,d),r.hidden&&(y.beginPath(),y.lineWidth=2,y.moveTo(a,d),y.lineTo(a+t,d),y.stroke()),O?g.x+=i+c.padding:g.y+=W})}}});function ee(e,o){var r=new Z({ctx:e.ctx,options:o,chart:e});$.configure(e,r,o),$.addBox(e,r),e.legend=r}var oe={id:"legend",_element:Z,beforeInit:function(e){var o=e.options.legend;o&&ee(e,o)},beforeUpdate:function(e){var o=e.options.legend,r=e.legend;o?(V.mergeIf(o,z.global.legend),r?($.configure(e,r,o),r.options=o):ee(e,o)):r&&($.removeBox(e,r),delete e.legend)},afterEvent:function(e,o){var r=e.legend;r&&r.handleEvent(o)}};o.StyleTooltip=l,o.helpers.style=x,o.elements.StyleArc=e,o.elements.StyleLine=i,o.elements.StylePoint=c,o.elements.StyleRectangle=b,o.controllers.bar=S,o.controllers.bubble=k,o.controllers.doughnut=o.controllers.pie=I,o.controllers.horizontalBar=M,o.controllers.line=o.controllers.scatter=E,o.controllers.polarArea=L,o.controllers.radar=q,o.plugins.getAll().forEach(function(e){"legend"===e.id&&o.plugins.unregister(e)}),o.plugins.register(oe),o.Legend=oe._element});